Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py	(revision 8291)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/applicant.py	(revision 8311)
@@ -32,4 +32,5 @@
     IObjectHistory, IFileStoreHandler, IFileStoreNameChooser, IKofaUtils,
     IExtFileStore, IPDF, IUserAccount)
+from waeup.kofa.interfaces import MessageFactory as _
 from waeup.kofa.students.vocabularies import RegNumNotInSource
 from waeup.kofa.utils.helpers import attrs_to_fields
@@ -80,10 +81,10 @@
 
     def createStudent(self, view=None):
-        """Create a student, fill with base data, create a StudentApplication
-        object and copy applicant data.
+        """Create a student, fill with base data, create an application slip
+        and copy applicant data.
         """
         # Is applicant in the correct state?
         if self.state != 'admitted':
-            return False, "Applicant has not yet been admitted."
+            return False, _('Applicant has not yet been admitted.')
         # Does registration number exist?
         student = createObject(u'waeup.Student')
@@ -91,8 +92,8 @@
             student.reg_number = self.reg_number
         except RegNumNotInSource:
-            return False, 'Registration Number exists.'
+            return False, _('Registration Number exists.')
         # Has the course_admitted field been properly filled?
         if self.course_admitted is None:
-            return False, 'No course admitted provided.'
+            return False, _('No course admitted provided.')
         # Add student object
         student.firstname = self.firstname
@@ -114,5 +115,5 @@
         student['studycourse'].entry_session = self.__parent__.year
         student['studycourse'].current_session = self.__parent__.year
-        student['studycourse'].current_level = self.__parent__.entry_level
+        student['studycourse'].current_level = self.course_admitted.start_level
         self._copyPassportImage(student)
         # Update the catalog
@@ -122,5 +123,5 @@
         self._createApplicationPDF(student, view=view)
 
-        return True, 'Student %s created' % student.student_id
+        return True, _('Student %s created') % student.student_id
 
     def _createApplicationPDF(self, student, view=None):
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/export.py	(revision 8291)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/export.py	(revision 8311)
@@ -33,5 +33,5 @@
 
     #: Fieldnames considered by this exporter
-    fields = ('code', 'title', 'prefix', 'entry_level', 'year',
+    fields = ('code', 'title', 'prefix', 'year',
               'application_category', 'description',
               'startdate', 'enddate', 'strict_deadline')
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py	(revision 8291)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/interfaces.py	(revision 8311)
@@ -188,10 +188,4 @@
         )
 
-    entry_level = schema.Choice(
-        title = _(u'Entry Level'),
-        vocabulary = course_levels,
-        required = True,
-        )
-
     # Maybe Uniben still needs this ...
     #ac_prefix = schema.Choice(
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py	(revision 8291)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_batching.py	(revision 8311)
@@ -153,5 +153,4 @@
         self.assertEqual(container.title, u'General Studies 2012/2013')
         self.assertEqual(container.prefix, u'app')
-        self.assertEqual(container.entry_level, 100)
         self.assertEqual(container.year, 2012)
         self.assertEqual(container.application_category, 'basic')
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 8291)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 8311)
@@ -86,5 +86,4 @@
         applicantscontainer.prefix = 'app'
         applicantscontainer.year = 2009
-        applicantscontainer.entry_level = 100
         applicantscontainer.application_category = 'basic'
         applicantscontainer.mode = 'create'
@@ -251,5 +250,4 @@
         self.browser.getControl(name="form.prefix").value = ['app']
         self.browser.getControl(name="form.year").value = ['2010']
-        self.browser.getControl(name="form.entry_level").value = ['100']
         self.browser.getControl(name="form.mode").value = ['create']
         self.browser.getControl(
@@ -266,5 +264,4 @@
         self.browser.getControl(name="form.prefix").value = ['app']
         self.browser.getControl(name="form.year").value = ['2010']
-        self.browser.getControl(name="form.entry_level").value = ['100']
         self.browser.getControl(name="form.mode").value = ['create']
         self.browser.getControl(
@@ -281,5 +278,4 @@
         self.browser.getControl(name="form.prefix").value = ['app']
         self.browser.getControl(name="form.year").value = ['2010']
-        self.browser.getControl(name="form.entry_level").value = ['100']
         self.browser.getControl(name="form.mode").value = ['create']
         #self.browser.getControl(name="form.ac_prefix").value = ['APP']
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_export.py	(revision 8291)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_export.py	(revision 8311)
@@ -53,5 +53,4 @@
         container.prefix = list(ApplicationTypeSource()(container))[0]
         container.year = 2012
-        container.entry_level = 100
         container.application_category = list(AppCatSource()(container))[0]
         container.description = u'Some Description\nwith linebreak\n'
@@ -72,8 +71,8 @@
         self.assertEqual(
             result,
-            'code,title,prefix,entry_level,year,application_category,'
+            'code,title,prefix,year,application_category,'
             'description,startdate,enddate,strict_deadline\r\n'
 
-            'dp2012,General Studies 2012/13,app,100,2012,basic,'
+            'dp2012,General Studies 2012/13,app,2012,basic,'
             '"Some Description\nwith linebreak\n<<de>>man spriht deutsh",'
             '2012-01-01 12:00:00+00:00,2012-01-31 23:00:00+00:00,1\r\n'