Index: WAeUP_SRP/trunk/skins/waeup_fceokene/admission_slip.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_fceokene/admission_slip.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_fceokene/admission_slip.pt	(revision 8329)
@@ -36,6 +36,6 @@
         <span tal:define="f_id sc/faculty;
                         d_id sc/department;
-                        f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-                        d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus"
+                        f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+                        d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus"
                         >
             <tr>
Index: WAeUP_SRP/trunk/skins/waeup_fceoyo/transcript_slip.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_fceoyo/transcript_slip.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_fceoyo/transcript_slip.pt	(revision 8329)
@@ -30,6 +30,6 @@
                entry_session sc/entry_session;
                perm_address sc/perm_address;
-               f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-               d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus;
+               f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+               d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus;
                sc_title context/academics/?f_id/?d_id/certificates/?sc_id/Title|string:Course not in Prospectus"
                >
Index: WAeUP_SRP/trunk/skins/waeup_futminna/admission_form.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_futminna/admission_form.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_futminna/admission_form.pt	(revision 8329)
@@ -50,6 +50,6 @@
           <span tal:define="f_id sc/faculty;
           d_id sc/department;
-          f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-          d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus"
+          f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+          d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus"
           >
             <tr>
Index: WAeUP_SRP/trunk/skins/waeup_futminna/study_course_view.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_futminna/study_course_view.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_futminna/study_course_view.pt	(revision 8329)
@@ -44,6 +44,6 @@
         d_id sc/department;
         c_id sc/study_course;
-        f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-        d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus;
+        f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+        d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus;
         c_title context/academics/?f_id/?d_id/certificates/?c_id/Title|string:Department not yet in Prospectus"
         >
Index: WAeUP_SRP/trunk/skins/waeup_futminna/transcript_slip.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_futminna/transcript_slip.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_futminna/transcript_slip.pt	(revision 8329)
@@ -30,6 +30,6 @@
                entry_session sc/entry_session;
                perm_address sc/perm_address;
-               f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-               d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus;
+               f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+               d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus;
                sc_title context/academics/?f_id/?d_id/certificates/?sc_id/Title|string:Course not in Prospectus"
                >
Index: WAeUP_SRP/trunk/skins/waeup_ois/clearance_slip.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_ois/clearance_slip.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_ois/clearance_slip.pt	(revision 8329)
@@ -22,6 +22,6 @@
                d_id sc/department;
                sc_id sc/course;
-               f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-               d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus;
+               f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+               d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus;
                sc_title context/academics/?f_id/?d_id/certificates/?sc_id/Title|string:Course not in Prospectus"
                >
Index: WAeUP_SRP/trunk/skins/waeup_ois/study_course_view.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_ois/study_course_view.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_ois/study_course_view.pt	(revision 8329)
@@ -46,6 +46,6 @@
         d_id sc/department;
         c_id sc/study_course;
-        f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-        d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus;
+        f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+        d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus;
         c_title context/academics/?f_id/?d_id/certificates/?c_id/Title|string:Department not yet in Prospectus"
         >
Index: WAeUP_SRP/trunk/skins/waeup_student/admission_form.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/admission_form.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_student/admission_form.pt	(revision 8329)
@@ -50,6 +50,6 @@
           <span tal:define="f_id sc/faculty;
           d_id sc/department;
-          f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-          d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus"
+          f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+          d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus"
           >
             <tr>
Index: WAeUP_SRP/trunk/skins/waeup_student/admission_slip.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_student/admission_slip.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_student/admission_slip.pt	(revision 8329)
@@ -36,6 +36,6 @@
         <span tal:define="f_id sc/faculty;
                         d_id sc/department;
-                        f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-                        d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus"
+                        f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+                        d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus"
                         >
             <tr>
Index: WAeUP_SRP/trunk/skins/waeup_uniben/admission_form.pt
===================================================================
--- WAeUP_SRP/trunk/skins/waeup_uniben/admission_form.pt	(revision 8324)
+++ WAeUP_SRP/trunk/skins/waeup_uniben/admission_form.pt	(revision 8329)
@@ -50,6 +50,6 @@
           <span tal:define="f_id sc/faculty;
           d_id sc/department;
-          f_title context/academics/?f_id/Title|string:Faculty not yet in Prospectus;
-          d_title context/academics/?f_id/?d_id/Title|string:Department not yet in Prospectus"
+          f_title context/academics/?f_id/LongTitle|string:Faculty not yet in Prospectus;
+          d_title context/academics/?f_id/?d_id/LongTitle|string:Department not yet in Prospectus"
           >
             <tr>