Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 8360)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 8361)
@@ -62,5 +62,6 @@
 from waeup.kofa.university.vocabularies import course_levels
 from waeup.kofa.authentication import LocalRoleSetEvent
-from waeup.kofa.widgets.restwidget import ReSTDisplayWidget
+#from waeup.kofa.widgets.restwidget import ReSTDisplayWidget
+from waeup.kofa.widgets.htmlwidget import HTMLDisplayWidget
 from waeup.kofa.authentication import get_principal_role_manager
 from waeup.kofa.utils.helpers import get_user_account
@@ -623,5 +624,5 @@
     label = _(u'View portal configuration')
     form_fields = grok.AutoFields(IConfigurationContainer)
-    form_fields['frontpage'].custom_widget = ReSTDisplayWidget
+    form_fields['frontpage'].custom_widget = HTMLDisplayWidget
 
 class ConfigurationContainerManageFormPage(KofaEditFormPage):
Index: main/waeup.kofa/trunk/src/waeup/kofa/frontpage.html
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/frontpage.html	(revision 8361)
+++ main/waeup.kofa/trunk/src/waeup/kofa/frontpage.html	(revision 8361)
@@ -0,0 +1,56 @@
+<h1>Welcome to Kofa</h1>
+
+<p>
+This is the default frontpage written in HTML.
+</p>
+
+<h1>1. Heading</h1>
+
+<p>Text</p>
+
+<h2>1.2 Heading</h2>
+
+Text
+
+<h1>2. Heading</h1>
+
+<p>Text</p>
+
+<h2>2.1 Heading</h2>
+
+<p>Text</p>
+
+<h2>2.2 Heading</h2>
+
+<p>Text</p>
+
+>>de<<
+<h1>Willkommen in Kofa</h1>
+
+<p>
+Dies ist die Standard-Startseite des Portals, die in HTML geschrieben wurde.
+</p>
+
+<p>
+ Weitere reST-Beispiele zur Einführung:
+</p>
+
+<h1>1. Überschrift</h1>
+
+<p>Text</p>
+
+<h2>1.2 Überschrift</h2>
+
+Text
+
+<h1>2. Überschrift</h1>
+
+<p>Text</p>
+
+<h2>2.1 Überschrift</h2>
+
+<p>Text</p>
+
+<h2>2.2 Überschrift</h2>
+
+<p>Text</p>
Index: main/waeup.kofa/trunk/src/waeup/kofa/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/interfaces.py	(revision 8360)
+++ main/waeup.kofa/trunk/src/waeup/kofa/interfaces.py	(revision 8361)
@@ -50,6 +50,10 @@
 VALIDATED = 'courses validated'
 
-default_frontpage = u'' + codecs.open(os.path.join(
-        os.path.dirname(__file__), 'frontpage.rst'),
+#default_rest_frontpage = u'' + codecs.open(os.path.join(
+#        os.path.dirname(__file__), 'frontpage.rst'),
+#        encoding='utf-8', mode='rb').read()
+
+default_html_frontpage = u'' + codecs.open(os.path.join(
+        os.path.dirname(__file__), 'frontpage.html'),
         encoding='utf-8', mode='rb').read()
 
@@ -494,7 +498,7 @@
 
     frontpage = schema.Text(
-        title = _(u'Content in reST format'),
+        title = _(u'Content in HTML format'),
         required = False,
-        default = default_frontpage,
+        default = default_html_frontpage,
         )
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/widgets/htmlwidget.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/widgets/htmlwidget.py	(revision 8361)
+++ main/waeup.kofa/trunk/src/waeup/kofa/widgets/htmlwidget.py	(revision 8361)
@@ -0,0 +1,58 @@
+## $Id$
+##
+## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
+"""A widget that renders localized html.
+"""
+from zope.component import getUtility
+from zope.formlib.widget import renderElement, DisplayWidget
+from waeup.kofa.interfaces import IKofaUtils
+
+
+class HTMLDisplayWidget(DisplayWidget):
+    """Restructured Text widget.
+    """
+
+    def __call__(self):
+        """The HTMLDisplayWidget transforms an localizez HTML text string into
+        a dictionary.
+
+        Different languages must be separated by `>>xy<<` whereas
+        xy is the language code. Text parts without correct leading
+        language separator - usually the first part has no language
+        descriptor - are interpreted as texts in the portal's language.
+        The latter can be configured in waeup.srp.utils.utils.KofaUtils.
+        """
+        if self._renderedValueSet():
+            value = self._data
+        else:
+            value = self.context.default
+        if value == self.context.missing_value:
+            return {}
+        parts = value.split('>>')
+        elements = {}
+        lang = getUtility(IKofaUtils).PORTAL_LANGUAGE
+        for part in parts:
+            if part[2:4] == u'<<':
+                lang = part[0:2].lower()
+                text = part[4:]
+                elements[lang] = renderElement(u'div id="html"',
+                    contents=text)
+            else:
+                text = part
+                elements[lang] = renderElement(u'div id="html"',
+                    contents=text)
+        return elements