Index: /main/waeup.kofa/trunk/src/waeup/kofa/applicants/permissions.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/applicants/permissions.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/applicants/permissions.py	(revision 8367)
@@ -46,5 +46,5 @@
     grok.title(u'Application Owner')
     grok.permissions('waeup.handleApplication', 'waeup.viewApplication',
-                     'waeup.Authenticated', 'waeup.payApplicant')
+                     'waeup.payApplicant')
 
 # Site role
@@ -52,9 +52,10 @@
 class ApplicantRole(grok.Role):
     grok.name('waeup.Applicant')
-    grok.permissions('waeup.viewAcademics', 'waeup.viewMyApplicationDataTab')
+    grok.permissions('waeup.viewAcademics', 'waeup.viewMyApplicationDataTab',
+                     'waeup.Authenticated')
 
 class ApplicationsOfficer(grok.Role):
     grok.name('waeup.ApplicationsOfficer')
     grok.title(u'Applications Officer')
-    grok.permissions('waeup.manageApplication', 'waeup.viewApplication'
+    grok.permissions('waeup.manageApplication', 'waeup.viewApplication',
                      'waeup.viewApplicantsTab', 'waeup.payApplicant')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 8367)
@@ -311,5 +311,5 @@
     grok.name('administration')
     grok.context(IUniversity)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.managePortal')
     label = _(u'Administration')
     pnav = 0
@@ -356,5 +356,5 @@
     grok.context(IUniversity)
     grok.name('reindex')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.managePortal')
 
     def update(self,ctlg=None):
@@ -594,5 +594,5 @@
     grok.name('search')
     grok.template('searchpage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.viewAcademics')
     label = _(u"Search Academic Section")
     pnav = 1
@@ -863,5 +863,5 @@
     grok.name('import1')
     grok.template('datacenterimport1page')
-    grok.require('waeup.manageDataCenter')
+    grok.require('waeup.importData')
     label = _(u'Process CSV file')
     pnav = 0
@@ -893,5 +893,5 @@
     grok.name('import2')
     grok.template('datacenterimport2page')
-    grok.require('waeup.manageDataCenter')
+    grok.require('waeup.importData')
     label = _(u'Process CSV file')
     pnav = 0
@@ -1013,5 +1013,5 @@
     grok.name('import3')
     grok.template('datacenterimport3page')
-    grok.require('waeup.manageDataCenter')
+    grok.require('waeup.importData')
     label = _(u'Process CSV file')
     pnav = 0
@@ -1121,5 +1121,5 @@
     grok.name('import4')
     grok.template('datacenterimport4page')
-    grok.require('waeup.manageDataCenter')
+    grok.require('waeup.importData')
     label = _(u'Process CSV file')
     pnav = 0
@@ -1178,5 +1178,5 @@
     grok.name('logs')
     grok.template('datacenterlogspage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageDataCenter')
     label = _(u'Show logfiles')
     pnav = 0
@@ -1200,5 +1200,5 @@
     grok.name('show')
     grok.template('datacenterlogsshowfilepage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageDataCenter')
     title = _(u'Data Center')
     pnav = 0
@@ -1275,5 +1275,5 @@
     grok.name('export')
     grok.template('datacenterexportpage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageDataCenter')
     label = _('Download portal data as CSV file')
     pnav = 0
@@ -1302,5 +1302,5 @@
     grok.context(IDataCenter)
     grok.name('export.csv')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageDataCenter')
 
     def render(self, exporter=None):
@@ -1318,5 +1318,5 @@
     """
     grok.name('export.xml')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.managePortal')
 
     def render(self):
@@ -1335,5 +1335,5 @@
     """
     grok.name('importxml')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.managePortal')
 
     def update(self, xmlfile=None, CANCEL=None, SUBMIT=None):
@@ -1378,5 +1378,5 @@
     grok.context(IFacultiesContainer)
     grok.name('manage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     grok.template('facultiescontainermanagepage')
     pnav = 1
@@ -1412,5 +1412,5 @@
     """
     grok.context(IFacultiesContainer)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     grok.name('add')
     label = _('Add faculty')
@@ -1453,5 +1453,5 @@
     grok.context(IFaculty)
     grok.name('manage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     grok.template('facultymanagepage')
     pnav = 1
@@ -1527,5 +1527,5 @@
     grok.context(IFaculty)
     grok.name('add')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     label = _('Add department')
     form_fields = grok.AutoFields(IDepartmentAdd)
@@ -1621,5 +1621,5 @@
     grok.context(IDepartment)
     grok.name('manage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     pnav = 1
     grok.template('departmentmanagepage')
@@ -1723,5 +1723,5 @@
     grok.context(IDepartment)
     grok.name('addcourse')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     label = _(u'Add course')
     form_fields = grok.AutoFields(ICourseAdd)
@@ -1760,5 +1760,5 @@
     grok.context(IDepartment)
     grok.name('addcertificate')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     label = _(u'Add certificate')
     form_fields = grok.AutoFields(ICertificateAdd)
@@ -1814,5 +1814,5 @@
     grok.context(ICourse)
     grok.name('manage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     label = _(u'Edit course')
     pnav = 1
@@ -1863,5 +1863,5 @@
     grok.context(ICertificate)
     grok.name('manage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     pnav = 1
     label = _('Edit certificate')
@@ -1941,5 +1941,5 @@
     grok.context(ICertificate)
     grok.name('addcertificatecourse')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     form_fields = grok.AutoFields(ICertificateCourseAdd)
     pnav = 1
@@ -1990,5 +1990,5 @@
     grok.context(ICertificateCourse)
     grok.name('manage')
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     form_fields = grok.AutoFields(ICertificateCourse)
     label = _('Edit course referrer')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/viewlets.py	(revision 8367)
@@ -155,5 +155,5 @@
     grok.baseclass()
     grok.order(2)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     icon = 'actionicon_modify.png'
     target = '@@manage'
@@ -165,5 +165,5 @@
     grok.baseclass()
     grok.order(4)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     icon = 'actionicon_add.png'
     target = 'add'
@@ -175,5 +175,5 @@
     grok.baseclass()
     grok.order(4)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     icon = 'actionicon_delete.png'
     target = 'remove'
@@ -185,5 +185,5 @@
     grok.baseclass()
     grok.order(5)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     icon = 'actionicon_search.png'
     target = 'search'
@@ -236,5 +236,5 @@
 #     #grok.view(Index)
 #     grok.order(98)
-#     grok.require('waeup.manageUniversity')
+#     grok.require('waeup.managePortal')
 
 #class ImportXMLAction(grok.Viewlet):
@@ -242,5 +242,5 @@
 #    #grok.view(Index)
 #    grok.order(99)
-#    grok.require('waeup.manageUniversity')
+#    grok.require('waeup.managePortal')
 #
 #    def update(self):
@@ -259,5 +259,5 @@
     grok.context(IKofaObject)
     grok.order(5)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     icon = 'actionicon_modify.png' # File must exist in static/
     title = 'Text of link'
@@ -346,5 +346,5 @@
     every page the user is allowed to go to, if the user has also the
     permissions set by `grok.require()`. By default only users with
-    ``waeup.manageUniversity`` permission will see links defined by
+    ``waeup.manageAcademics`` permission will see links defined by
     this or derivated classes.
     """
@@ -523,5 +523,5 @@
     grok.template('actionbutton')
     grok.viewletmanager(ActionBar)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
     icon = 'actionicon_manage.png' # File must exist in static/
     target = '@@show' # link to this viewname.
@@ -542,5 +542,5 @@
     grok.context(IDataCenter)
     grok.view(DatacenterPage)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.importData')
     grok.order(6)
     icon = 'actionicon_gear.png'
@@ -551,5 +551,5 @@
     grok.context(IDataCenter)
     grok.view(DatacenterPage)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageDataCenter')
     grok.order(5)
     icon = 'actionicon_up.png'
@@ -560,5 +560,5 @@
     grok.context(IDataCenter)
     grok.view(DatacenterPage)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageDataCenter')
     grok.order(7)
     icon = 'actionicon_down.png'
@@ -657,5 +657,5 @@
     grok.order(1)
     grok.viewletmanager(AdministrationTasks)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.managePortal')
     grok.template('admintask')
 
@@ -765,5 +765,5 @@
     grok.viewletmanager(SubobjectLister)
     grok.context(IFaculty)
-    grok.require('waeup.manageUniversity')
+    grok.require('waeup.manageAcademics')
 
     def render(self):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/frontpage.html
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/frontpage.html	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/frontpage.html	(revision 8367)
@@ -1,3 +1,3 @@
-<h1>Welcome to WAeUP.Kofa,
+<h1>Welcome to WAeUP.Kofa
 <br>
 <small>
Index: /main/waeup.kofa/trunk/src/waeup/kofa/permissions.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/permissions.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/permissions.py	(revision 8367)
@@ -47,6 +47,9 @@
     grok.name('waeup.viewAcademics')
 
-class ManageUniversity(grok.Permission):
-    grok.name('waeup.manageUniversity')
+class ManageAcademicsPermission(grok.Permission):
+    grok.name('waeup.manageAcademics')
+
+class ManagePortal(grok.Permission):
+    grok.name('waeup.managePortal')
 
 class ManageUsers(grok.Permission):
@@ -61,4 +64,7 @@
 class ManageDataCenter(grok.Permission):
     grok.name('waeup.manageDataCenter')
+
+class ImportData(grok.Permission):
+    grok.name('waeup.importData')
 
 class ManagePortalConfiguration(grok.Permission):
@@ -72,5 +78,5 @@
     grok.name('waeup.local.DepartmentManager')
     grok.title(u'Department Manager')
-    grok.permissions('waeup.manageUniversity','waeup.showStudents')
+    grok.permissions('waeup.manageAcademics','waeup.showStudents')
 
 class ClearanceOfficer(grok.Role):
@@ -141,4 +147,10 @@
     grok.permissions('waeup.viewAcademics')
 
+class AcademicsManager(grok.Role):
+    grok.name('waeup.AcademicsManager')
+    grok.title(u'Academics Manager')
+    grok.permissions('waeup.viewAcademics',
+                     'waeup.manageAcademics')
+
 class ACManager(grok.Role):
     grok.name('waeup.ACManager')
@@ -146,10 +158,28 @@
     grok.permissions('waeup.manageACBatches')
 
+class DataCenterManager(grok.Role):
+    grok.name('waeup.DataCenterManager')
+    grok.title(u'Datacenter Manager')
+    grok.permissions('waeup.manageDataCenter')
+
+class ImportManager(grok.Role):
+    grok.name('waeup.ImportManager')
+    grok.title(u'Import Manager')
+    grok.permissions('waeup.manageDataCenter',
+                     'waeup.importData')
+
+class UsersManager(grok.Role):
+    grok.name('waeup.UsersManager')
+    grok.title(u'Users Manager')
+    grok.permissions('waeup.manageUsers')
+
 class PortalManager(grok.Role):
     grok.name('waeup.PortalManager')
     grok.title(u'Portal Manager')
-    grok.permissions('waeup.manageUniversity', 'waeup.manageUsers',
-                     'waeup.viewAcademics', 'waeup.manageACBatches',
+    grok.permissions('waeup.managePortal', 'waeup.manageUsers',
+                     'waeup.viewAcademics', 'manageAcademics',
+                     'waeup.manageACBatches',
                      'waeup.manageDataCenter','waeup.managePortalSettings',
+                     'waeup.importData',
                      'waeup.managePortalConfiguration', 'waeup.viewApplication',
                      'waeup.manageApplication', 'waeup.handleApplication',
Index: /main/waeup.kofa/trunk/src/waeup/kofa/permissions.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/permissions.txt	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/permissions.txt	(revision 8367)
@@ -39,8 +39,8 @@
     >>> from waeup.kofa.permissions import get_waeup_roles
     >>> len(list(get_waeup_roles()))
-    11
+    15
 
     >>> len(list(get_waeup_roles(also_local=True)))
-    22
+    26
 
 
@@ -54,8 +54,11 @@
     >>> list(get_waeup_role_names())
     [u'waeup.ACManager',
+     u'waeup.AcademicsManager',
      u'waeup.AcademicsOfficer',
      u'waeup.AccommodationOfficer',
      u'waeup.Applicant',
      u'waeup.ApplicationsOfficer',
+     u'waeup.DataCenterManager',
+     u'waeup.ImportManager',
      u'waeup.PortalManager',
      u'waeup.Student',
@@ -63,5 +66,6 @@
      u'waeup.StudentsCourseAdviser',
      u'waeup.StudentsManager',
-     u'waeup.StudentsOfficer']
+     u'waeup.StudentsOfficer',
+     u'waeup.UsersManager']
 
 :func:`get_users_with_local_roles`
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/permissions.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/permissions.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/permissions.py	(revision 8367)
@@ -62,10 +62,11 @@
     grok.permissions('waeup.handleStudent', 'waeup.uploadStudentFile',
                      'waeup.viewStudent', 'waeup.payStudent',
-                     'waeup.handleAccommodation', 'waeup.Authenticated')
+                     'waeup.handleAccommodation')
 
 # Site Roles
 class StudentRole(grok.Role):
     grok.name('waeup.Student')
-    grok.permissions('waeup.viewAcademics', 'waeup.viewMyStudentDataTab')
+    grok.permissions('waeup.viewAcademics', 'waeup.viewMyStudentDataTab',
+                     'waeup.Authenticated')
 
 class StudentsOfficer(grok.Role):
@@ -78,7 +79,8 @@
     grok.name('waeup.StudentsManager')
     grok.title(u'Students Manager')
-    grok.permissions('waeup.viewStudent', 'waeup.manageStudent',
+    grok.permissions('waeup.viewStudent', 'waeup.viewStudents',
+                     'waeup.manageStudent', 'waeup.viewStudentsContainer',
                      'waeup.payStudent', 'waeup.uploadStudentFile',
-                     'waeup.handleAccommodation', 'waeup.viewStudents')
+                     'waeup.viewStudentsTab', 'waeup.handleAccommodation')
 
 class StudentsClearanceOfficer(grok.Role):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/certificatescontainer.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/certificatescontainer.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/certificatescontainer.py	(revision 8367)
@@ -46,5 +46,4 @@
     """
     grok.implements(ICertificatesContainer)
-    grok.require('waeup.manageUniversity')
 
     def __setitem__(self, name, certificate):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/certificatescontainer.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/certificatescontainer.txt	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/certificatescontainer.txt	(revision 8367)
@@ -21,6 +21,4 @@
 
    .. attribute:: grok.implements(ICertificatesContainer)
-
-   .. attribute:: grok.require('waeup.manageUniversity')
 
    :class:`CertificatesContainer` instances are instances of
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/coursescontainer.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/coursescontainer.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/coursescontainer.py	(revision 8367)
@@ -30,5 +30,4 @@
     """
     grok.implements(ICoursesContainer)
-    grok.require('waeup.manageUniversity')
 
     def __setitem__(self, name, course):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/coursescontainer.txt
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/coursescontainer.txt	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/coursescontainer.txt	(revision 8367)
@@ -21,6 +21,4 @@
 
    .. attribute:: grok.implements(ICoursesContainer)
-
-   .. attribute:: grok.require('waeup.manageUniversity')
 
    :class:`CoursesContainer` instances are instances of
Index: /main/waeup.kofa/trunk/src/waeup/kofa/university/facultiescontainer.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/university/facultiescontainer.py	(revision 8366)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/university/facultiescontainer.py	(revision 8367)
@@ -26,5 +26,4 @@
     """
     grok.implements(IFacultiesContainer)
-    grok.require('waeup.manageUniversity')
 
     def addFaculty(self, faculty):